package ex5;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class CharReader {
    public static final char CHAR_EOF = (char) 0;
    private String line;
    private BufferedReader reader;
    private int lineLength;
    private int index;

    public CharReader(BufferedReader reader) {
        this.reader = reader;
        lineLength = 0;
        index = 1;
    }

    public char nextChar(){
        if(index <lineLength){
            return line.charAt(index++);
        }
        if(index++==lineLength){
            return '\n';
        }

        try {
            line=reader.readLine();
            if(line!=null){
                lineLength = line.length();
                index=0;
                System.out.println("line = " + line);//for debug
                return nextChar();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return CHAR_EOF;
    }
    public void backChar(){
        index--;
    }

    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        char c;
        CharReader cr = new CharReader(br);
        while((c = cr.nextChar()) != CHAR_EOF){
            System.out.println("c = " + c);
        }
    }
}
