package ex5;

import java.io.BufferedReader;
import java.io.InputStreamReader;

enum TokenClassA {
    IDENT
}

enum CharClassA {
    DIGIT, LETTER,OTHERS
}

public class ReadIdentifierA {
    StringBuilder stringBuffer;
    CharReader reader;

    public ReadIdentifierA(CharReader reader) {
        this.reader = reader;
        stringBuffer = new StringBuilder();
    }

    CharClassA getCharClass(char ch){
        if (Character.isDigit(ch))
            return CharClassA.DIGIT;
        if (Character.isLetter(ch))
            return CharClassA.LETTER;
        return CharClassA.OTHERS;
    }

    String currentString(){
        return stringBuffer.toString();
    }

    TokenClassA nextToken(){
        int nextState = 1;
        char ch;
        stringBuffer.setLength(0);
        loop:
        while(true){
            switch (nextState){
                case 1:
                    ch = reader.nextChar();
                    if (getCharClass(ch)== CharClassA.LETTER){
                        stringBuffer.append(ch);
                        nextState = 2;
                    } else
                        throw new RuntimeException("error: not an identifier");
                    break;
                case 2:
                    ch = reader.nextChar();
                    if (getCharClass(ch)== CharClassA.LETTER ||
                            getCharClass(ch) == CharClassA.DIGIT){
                        stringBuffer.append(ch);
                        nextState = 2;
                    } else {
                        nextState = 3;
                    }
                    break;
                case 3:
                    reader.backChar();
                    break loop;  // [v𔲂
            }
        }
        return TokenClassA.IDENT;
    }

    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        ReadIdentifierA tokenizer = new ReadIdentifierA(new CharReader(br));
        TokenClassA tc = tokenizer.nextToken();
        System.out.println("tc = " + tc);
        System.out.println("tokenizer.currentString() = " + tokenizer.currentString());
    }
}
